<template>
  <div class="flex flex-col">
    <div class="flex justify-center">
      <div class="text-xl text-white w-[40rem]">
        {{ question_str }}
      </div>
    </div>
    <div class="flex mt-4 items-center justify-center">
      <div class="inline-block">
        <a-input label="Amount of lodges:" placeholder="amount"
          :validators="amoutValidators" v-model="amount" />
        <submit-button value="find" @click="execute"/>
      </div>
      <sql-query-text>{{ sql_query }}</sql-query-text>
    </div>
    <div class="flex justify-center">
      <lodges />
    </div>

  </div>
</template>

<script>
import AInput from '@/components/AInput.vue';
import { positiveNumberValidator } from '@/components/Validators.js'
import SubmitButton from '@/components/SubmitButton.vue';
import TableBase from '@/components/TableBase.vue';
import SimpleSqlQueries from '@/assets/SimpleQueries.json';
import SqlQueryText from '@/components/SqlQueryText.vue';
import Lodges from '@/components/Lodges.vue';
import { mapMutations } from 'vuex';
import axiosClient from '@/axiosClient';
import { add_lodges } from '@/components/helpers';

export default {
  components: {
    AInput,
    SubmitButton,
    TableBase,
    SqlQueryText,
    Lodges
  },
  data() {
    return {
      amoutValidators: [positiveNumberValidator],
      question_str: SimpleSqlQueries[4].question,
      sql_query: SimpleSqlQueries[4].query,
      amount: undefined,
    }
  },
  methods: {
    ...mapMutations(['clearLodges']),
    execute() {
      axiosClient.get('simple-query/5', {headers:{n:this.amount}})
      .then((response) => {
        this.clearLodges()
        add_lodges(response)
      })
    }
  },
  mounted() {
    this.clearLodges()
  }
}


</script>